function topPosition(domElt) {
  if (!domElt) {
    return 0;
  }
  return domElt.offsetTop + topPosition(domElt.offsetParent);
}

module.exports = function (React) {
  if (React.addons && React.addons.InfiniteScroll) {
    return React.addons.InfiniteScroll;
  }
  React.addons = React.addons || {};
  var InfiniteScroll = React.addons.InfiniteScroll = React.createClass({
    getDefaultProps: function () {
      return {
        pageStart: 0,
        hasMore: false,
        loadMore: function () {},
        threshold: 250
      };
    },
    getInitialState: function () {
      return {
        loading: false,
        error: false
      };
    },
    componentDidMount: function () {
      this.pageLoaded = this.props.pageStart;
      this.attachScrollListener();
    },
    componentDidUpdate: function () {
      this.attachScrollListener();
    },
    render: function () {
      var props = this.props;
      var state = this.state;
      return React.DOM.div(null, props.children, state.loading && (props.loader || InfiniteScroll._defaultLoader),
        state.error && (props.errorRetry));
    },
    scrollListener: function () {
      var el = this.getDOMNode();
      var scrollTop = (window.pageYOffset !== undefined) ? window.pageYOffset : (document.documentElement || document.body.parentNode || document.body).scrollTop;
      if (topPosition(el) + el.offsetHeight - scrollTop - window.innerHeight < Number(this.props.threshold)) {
        this.detachScrollListener();
        // call loadMore after detachScrollListener to allow
        // for non-async loadMore functions
        var promise = this.props.loadMore(this.pageLoaded += 1);
        if (!promise || typeof promise.then !== 'function') {
          throw new Error('loadMore must return a Promise!');
        }
        promise.then(function () {
          this.setState({
            loading: false,
            error: false
          });
        }, function () {
          this.setState({
            loading: false,
            error: true
          });
        });
        // What if promise has failed?
        // We can display 'retry' button I suppose - But that involves using
        // a state etc.
        this.setState({
          loading: true,
          error: false
        });
      }
    },
    attachScrollListener: function () {
      if (!this.props.hasMore || !this.state.loading && !this.state.error) {
        return;
      }
      window.addEventListener('scroll', this.scrollListener);
      window.addEventListener('resize', this.scrollListener);
      this.scrollListener();
    },
    detachScrollListener: function () {
      window.removeEventListener('scroll', this.scrollListener);
      window.removeEventListener('resize', this.scrollListener);
    },
    componentWillUnmount: function () {
      this.detachScrollListener();
    }
  });
  InfiniteScroll.setDefaultLoader = function (loader) {
    InfiniteScroll._defaultLoader = loader;
  };
  return InfiniteScroll;
};
